# implicit_euler.py
import numpy as np
import matplotlib.pyplot as plt
def f(t,y):
    return np.cos(2*t)*y**2
def Phi(t,y_old,y_new,tau):
  return f(t+tau,y_new)
def save_solution(y,K):
    with open('sol.dat','w') as f:
        for k in range(K):
            f.write("{:>10.4f} \n".format(y[k]))
""" MAIN PROG """
y_0 = 1.0; T = 10.0; tau = 1.0/100
eps_stop = tau/10; K = int(np.floor(T/tau))
y = np.zeros(K+1); t_list = np.zeros(K+1)
y[0] = y_0; t_list[0] = 0
for k in range(K):
    t_k = k*tau
    z = y[k]
    diff = 1
    while (diff>eps_stop):
        z_new = y[k]+tau*Phi(t_k,y[k],z,tau)
        diff = abs(z_new-z)
        z = z_new
    y[k+1] = z; t_list[k+1] = t_k+tau
save_solution(y,K);
plt.plot(t_list,y)
plt.show()
