// lu_solution.cc
#include <iostream>
const int n = 3;
void lu_crout(double A[n][n]){
  double s; 
  for (int i=0; i<n; i++){
    for (int k=i; k<n; k++){
      s = 0.0;
      for (int j=0; j<=i-1; j++){s = s+A[i][j]*A[j][k];}
      A[i][k] = A[i][k]-s;
    }
    for (int k=i+1; k<n; k++){
      s = 0.0;
      for (int j=0;j<=i-1;j++){s = s+A[k][j]*A[j][i];}
      A[k][i] = (A[k][i]-s)/A[i][i];
    }
  }
} 
void solve_lower_normalized(double L[n][n], double b[n], 
			    double y[n]){
  double s;
  for (int j=0; j<n; j++){
    s = 0.0;
    for (int k=0; k<=j-1; k++){s = s+L[j][k]*y[k];}
    y[j] = b[j]-s;
  }
}  
void solve_upper(double U[n][n], double y[n], double x[n]){
  double s;
  for (int j=n-1; j>=0; j--){
    s = 0.0;
    for (int k=j+1; k<n; k++){s = s+U[j][k]*x[k];}
    x[j] = (y[j]-s)/U[j][j];
  }
}
int main(){
  double x[n], y[n]; 
  double A[n][n] = {{2.,-1.,0.},{-1.,2.,-1.},{0.,-1.,2.}};
  double b[n] = {1.,1.,1.};
  lu_crout(A);
  solve_lower_normalized(A,b,y);
  solve_upper(A,y,x);
  for (int i=0; i<n; i++){
    std::cout << "x[" << i << "] = " << x[i] << "\n";
  }
}
