function lu_solution
n = 3; 
A = [2,-1,0;-1,2,-1;0,-1,2]; 
b = [1;1;1];
A = lu_crout(n,A);
y = solve_lower_normalized(n,A,b);
x = solve_upper(n,A,y);
disp(x);

function A = lu_crout(n,A)
for i = 1:n
    for k = i:n
        s = 0;
        for j = 1:i-1
            s = s+A(i,j)*A(j,k);
        end
        A(i,k) = A(i,k)-s;
    end
    for k = i+1:n
        s = 0;
        for j=1:i-1
            s = s+A(k,j)*A(j,i);
        end
        A(k,i) = (A(k,i)-s)/A(i,i);
    end
end

function y = solve_lower_normalized(n,L,b)
y = zeros(n,1);
for j = 1:n
    sum = 0;
    for k = 1:j-1
        sum = sum+L(j,k)*y(k);
    end
    y(j) = b(j)-sum;
end

function x = solve_upper(n,U,y)
x = zeros(n,1);
for j = n:-1:1
    sum = 0;
    for k = j+1:n
        sum = sum+U(j,k)*x(k);
    end
    x(j) = (y(j)-sum)/U(j,j);
end
