# lu_solution.py
import numpy as np
def lu_crout(A,n):
    for i in range(n):
        for k in range(i,n):
            s = 0.0
            for j in range(i):
                s = s+A[i][j]*A[j][k]
            A[i][k] = A[i][k]-s
        for k in range(i+1,n):
            s = 0.0
            for j in range(0,i):
                s = s+A[k][j]*A[j][i]
            A[k][i] = (A[k][i]-s)/A[i][i]
def solve_lower_normalized(L,b,y):
    for j in range(n):
        s = 0.0
        for k in range(0,j):
            s = s+L[j][k]*y[k]
        y[j] = b[j]-s
def solve_upper(U,y,x):
    for j in range(n-1,-1,-1):
        s = 0.0
        for k in range(j+1,n):
            s = s+U[j][k]*x[k]
        x[j] = (y[j]-s)/U[j][j]
""" MAIN PROG """
n = 3;
A = np.array([[2.0,-1.0,0.0],[-1.0,2.0,-1.0],[0.0,-1.0,2.0]])
b = np.ones(n); y = np.zeros(n); x = np.zeros(n)
lu_crout(A,n)
solve_lower_normalized(A,b,y)
solve_upper(A,y,x);
print(x)
