// neville_scheme.cc
#include <iostream>
#include <vector>
typedef typename std::vector<double> doubleVec;
const int n = 3;
double neville_recursive(double z, doubleVec x, doubleVec y,
			 int i, int j){
  if (j==0){
    return y[i];
  }
  else{
    return ((z-x[i])*neville_recursive(z,x,y,i+1,j-1)
	 -(z-x[i+j])*neville_recursive(z,x,y,i,j-1))/(x[i+j]-x[i]);
  }
}
double neville_forward(double z, doubleVec x, doubleVec y){
  double P[n+1][n+1]; 
  for (int i=0; i<=n; i++){
    P[i][0] = y[i];
  }
  for (int j=1; j<=n; j++){
    for (int i=0; i<=n-j; i++){
      P[i][j] = ((z-x[i])*P[i+1][j-1]-(z-x[i+j])*P[i][j-1])/
	(x[i+j]-x[i]);
    }
  }
  return P[0][n];
}
int main(){
  int N = 20;
  doubleVec x(n+1), y(n+1); 
  doubleVec z(N+1), w_rec(N+1), w_for(N+1);
  x[0] =-1.0; x[1] =-1.0/3; x[2] = 1.0/3; x[3] = 1.0;
  y[0] =-1.0; y[1] = 1.0;   y[2] =-1.0;   y[3] = 1.0;
  for (int k=0; k<=N; k++){
    z[k] = -1.0+2.0*(double)k/N;
    w_rec[k] = neville_recursive(z[k],x,y,0,n);
    w_for[k] = neville_forward(z[k],x,y);
    std::cout << "w_rec = " << w_rec[k] << ", "; 
    std::cout << "w_for = " << w_for[k] << "\n";
  }
}
