function neville_scheme
n = 3; 
x = [-1,-1/3,1/3,1]; 
y = [-1,1,-1,1];
N = 20; z = zeros(N+1,1);
w_rec = zeros(N+1,1); 
w_for = zeros(N+1,1);
for k = 0:N
    z(k+1) = -1+2*k/N;
    w_rec(k+1) = neville_recursive(z(k+1),x,y,0,n);
    w_for(k+1) = neville_forward(z(k+1),x,y,n);
end
plot(z,w_rec,'b-o'); hold on;
plot(z,w_for,'r-x'); hold off;

function val = neville_recursive(z,x,y,i,j)
if j == 0
    val = y(i+1);
else
    val = ((z-x(i+1))*neville_recursive(z,x,y,i+1,j-1)...
        -(z-x(i+j+1))*neville_recursive(z,x,y,i,j-1))/...
        (x(i+j+1)-x(i+1));
end

function val = neville_forward(z,x,y,n)
P = zeros(n+1,n+1);
for i = 0:n
    P(i+1,1) = y(i+1);
end
for j = 1:n
    for i = 0:n-j
        P(i+1,j+1) = ((z-x(i+1))*P(i+2,j)...
            -(z-x(i+j+1))*P(i+1,j))/(x(i+j+1)-x(i+1));
    end
end
val = P(1,n+1);
