# neville_scheme.py
import numpy as np
def neville_recursive(z,x,y,i,j):
    if (j==0):
        return y[i]
    else:
        return ((z-x[i])*neville_recursive(z,x,y,i+1,j-1) \
                -(z-x[i+j])*neville_recursive(z,x,y,i,j-1)) \
                /(x[i+j]-x[i])
def neville_forward(z,x,y,n):
    P = np.zeros((n+1,n+1))
    for i in range(n+1):
        P[i][0] = y[i]
    for j in range(1,n+1):
        for i in range(n-j+1):
            P[i][j] = ((z-x[i])*P[i+1][j-1]- \
                       (z-x[i+j])*P[i][j-1])/ \
                       (x[i+j]-x[i])
    return P[0][n]
""" MAIN PROG """
n = 3; N = 20
x = np.array([-1,-1/3,1/3,1])
y = np.array([-1,1,-1,1])
z = np.zeros(N+1);
w_rec = np.zeros(N+1); w_for = np.zeros(N+1)
for k in range(N+1):
    z[k] = -1+2*k/N;
    w_rec[k] = neville_recursive(z[k],x,y,0,n);
    w_for[k] = neville_forward(z[k],x,y,n);
    print("w_rec = {:>7.4f}, w_for = {:>7.4f}" \
          .format(w_rec[k],w_for[k]))

